# mypy-boto3-organizations

[![PyPI - mypy-boto3-organizations](https://img.shields.io/pypi/v/mypy-boto3-organizations.svg?color=blue)](https://pypi.org/project/mypy-boto3-organizations)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-organizations.svg?color=blue)](https://pypi.org/project/mypy-boto3-organizations)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

- [mypy-boto3-organizations](#mypy-boto3-organizations)
  - [How to use](#how-to-use)
  - [Automated type discovery](#automated-type-discovery)

Type annotations for
[boto3.Organizations 1.13.26](https://boto3.amazonaws.com/v1/documentation/api/1.13.26/reference/services/organizations.html#Organizations) service
compatible with [mypy](https://github.com/python/mypy), [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/) and other tools.

Generated by [mypy-boto3-buider 2.0.4](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

## How to use

Make sure you have [mypy](https://github.com/python/mypy) installed and activated in your IDE.

Install `boto3-stubs` for `Organizations` service.

```bash
python -m pip install boto3-stubs[organizations]
```

Use `boto3` with `mypy_boto3_organizations` in your project and enjoy type checking and auto-complete.

```python
import boto3

from mypy_boto3_organizations import OrganizationsClient

# Now mypy can check if your code is valid.
client: OrganizationsClient = boto3.client("organizations")

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: OrganizationsClient = session.client("organizations")



# Annotated paginators are included as well

import mypy_boto3_organizations.paginator as organizations_paginators

list_aws_service_access_for_organization_paginator: organizations_paginators.ListAWSServiceAccessForOrganizationPaginator = client.get_paginator("list_aws_service_access_for_organization")
list_accounts_paginator: organizations_paginators.ListAccountsPaginator = client.get_paginator("list_accounts")
list_accounts_for_parent_paginator: organizations_paginators.ListAccountsForParentPaginator = client.get_paginator("list_accounts_for_parent")
list_children_paginator: organizations_paginators.ListChildrenPaginator = client.get_paginator("list_children")
list_create_account_status_paginator: organizations_paginators.ListCreateAccountStatusPaginator = client.get_paginator("list_create_account_status")
list_delegated_administrators_paginator: organizations_paginators.ListDelegatedAdministratorsPaginator = client.get_paginator("list_delegated_administrators")
list_delegated_services_for_account_paginator: organizations_paginators.ListDelegatedServicesForAccountPaginator = client.get_paginator("list_delegated_services_for_account")
list_handshakes_for_account_paginator: organizations_paginators.ListHandshakesForAccountPaginator = client.get_paginator("list_handshakes_for_account")
list_handshakes_for_organization_paginator: organizations_paginators.ListHandshakesForOrganizationPaginator = client.get_paginator("list_handshakes_for_organization")
list_organizational_units_for_parent_paginator: organizations_paginators.ListOrganizationalUnitsForParentPaginator = client.get_paginator("list_organizational_units_for_parent")
list_parents_paginator: organizations_paginators.ListParentsPaginator = client.get_paginator("list_parents")
list_policies_paginator: organizations_paginators.ListPoliciesPaginator = client.get_paginator("list_policies")
list_policies_for_target_paginator: organizations_paginators.ListPoliciesForTargetPaginator = client.get_paginator("list_policies_for_target")
list_roots_paginator: organizations_paginators.ListRootsPaginator = client.get_paginator("list_roots")
list_tags_for_resource_paginator: organizations_paginators.ListTagsForResourcePaginator = client.get_paginator("list_tags_for_resource")
list_targets_for_policy_paginator: organizations_paginators.ListTargetsForPolicyPaginator = client.get_paginator("list_targets_for_policy")
```

## Dynamic type annotations

`mypy_boto3` command generates `boto3.client/resource` type annotations for
`mypy_boto3_organizations` and other installed services.

```bash
# Run this command after you add or remove service packages
python -m mypy_boto3
```

Generated type annotations provide overloads for `boto3.client` and `boto3.resource`,
`boto3.Session.client` and `boto3.Session.resource` functions,
so explicit type annotations are not needed.

- `mypy` supports function overloads as expected
- `PyCharm` also supports function overloads, but consumes a lot of RAM, use carefully if you have many services installed
- `VSCode` does not currently support function overloads, use explicit type annotations

```python
import boto3

# Type is discovered correctly by mypy and PyCharm
# VSCode still needs explicit type annotations
client = boto3.client("organizations")

session_client = boto3.Session().client("organizations")
```